package org.jboss.errai.enterprise.client.jaxrs;

import com.google.gwt.http.client.RequestBuilder;
import com.kdm.erraiexample.shared.SearchService;
import com.kdm.provider.data.SearchResult;
import org.jboss.errai.common.client.api.ErrorCallback;
import org.jboss.errai.common.client.api.RemoteCallback;
import org.jboss.errai.common.client.framework.ProxyProvider;
import org.jboss.errai.common.client.framework.RemoteServiceProxyFactory;

public class JaxrsProxyLoaderImpl implements JaxrsProxyLoader { public void loadProxies() {
    class com_kdm_erraiexample_shared_SearchServiceImpl extends AbstractJaxrsProxy implements SearchService {
      private RemoteCallback remoteCallback;
      private ErrorCallback errorCallback;
      public com_kdm_erraiexample_shared_SearchServiceImpl() {

      }

      public RemoteCallback getRemoteCallback() {
        return remoteCallback;
      }

      public void setRemoteCallback(RemoteCallback callback) {
        remoteCallback = callback;
      }

      public ErrorCallback getErrorCallback() {
        return errorCallback;
      }

      public void setErrorCallback(ErrorCallback callback) {
        errorCallback = callback;
      }

      public SearchResult search(final String a0) {
        StringBuilder url = new StringBuilder(getBaseUrl());
        url.append("e-search");
        RequestBuilder requestBuilder = new RequestBuilder(RequestBuilder.POST, url.toString());
        requestBuilder.setHeader("Accept", "application/json");
        requestBuilder.setHeader("Content-Type", "application/json");
        sendRequest(requestBuilder, a0 == null ? "" : a0, new ResponseDemarshallingCallback() {
          public Object demarshallResponse(String response) {
            return MarshallingWrapper.fromJSON(response, SearchResult.class, null);
          }
        });
        return null;
      }
    }
    RemoteServiceProxyFactory.addRemoteProxy(SearchService.class, new ProxyProvider() {
      public Object getProxy() {
        return new com_kdm_erraiexample_shared_SearchServiceImpl();
      }
    });
  }
}